import modal.client
import modal.stream_type
import typing
import typing_extensions

def _sandbox_logs_iterator(
    sandbox_id: str, file_descriptor: int, last_entry_id: str, client: modal.client._Client
) -> typing.AsyncGenerator[typing.Tuple[typing.Optional[bytes], str], None]: ...
def _container_process_logs_iterator(
    process_id: str, file_descriptor: int, client: modal.client._Client
) -> typing.AsyncGenerator[typing.Optional[bytes], None]: ...

T = typing.TypeVar("T")

class _StreamReader(typing.Generic[T]):
    _stream: typing.Optional[typing.AsyncGenerator[typing.Optional[bytes], None]]

    def __init__(
        self,
        file_descriptor: int,
        object_id: str,
        object_type: typing.Literal["sandbox", "container_process"],
        client: modal.client._Client,
        stream_type: modal.stream_type.StreamType = modal.stream_type.StreamType.PIPE,
        text: bool = True,
        by_line: bool = False,
    ) -> None: ...
    @property
    def file_descriptor(self): ...
    async def read(self) -> T: ...
    async def _consume_container_process_stream(self): ...
    def _stream_container_process(self) -> typing.AsyncGenerator[typing.Tuple[typing.Optional[bytes], str], None]: ...
    def _get_logs(self) -> typing.AsyncGenerator[typing.Optional[bytes], None]: ...
    def _get_logs_by_line(self) -> typing.AsyncGenerator[typing.Optional[bytes], None]: ...
    def __aiter__(self) -> typing.AsyncIterator[T]: ...
    async def __anext__(self) -> T: ...

class _StreamWriter:
    def __init__(
        self, object_id: str, object_type: typing.Literal["sandbox", "container_process"], client: modal.client._Client
    ): ...
    def get_next_index(self): ...
    def write(self, data: typing.Union[bytes, bytearray, memoryview, str]): ...
    def write_eof(self): ...
    async def drain(self): ...

T_INNER = typing.TypeVar("T_INNER", covariant=True)

class StreamReader(typing.Generic[T]):
    _stream: typing.Optional[typing.AsyncGenerator[typing.Optional[bytes], None]]

    def __init__(
        self,
        file_descriptor: int,
        object_id: str,
        object_type: typing.Literal["sandbox", "container_process"],
        client: modal.client.Client,
        stream_type: modal.stream_type.StreamType = modal.stream_type.StreamType.PIPE,
        text: bool = True,
        by_line: bool = False,
    ) -> None: ...
    @property
    def file_descriptor(self): ...

    class __read_spec(typing_extensions.Protocol[T_INNER]):
        def __call__(self) -> T_INNER: ...
        async def aio(self) -> T_INNER: ...

    read: __read_spec[T]

    class ___consume_container_process_stream_spec(typing_extensions.Protocol):
        def __call__(self): ...
        async def aio(self): ...

    _consume_container_process_stream: ___consume_container_process_stream_spec

    class ___stream_container_process_spec(typing_extensions.Protocol):
        def __call__(self) -> typing.Generator[typing.Tuple[typing.Optional[bytes], str], None, None]: ...
        def aio(self) -> typing.AsyncGenerator[typing.Tuple[typing.Optional[bytes], str], None]: ...

    _stream_container_process: ___stream_container_process_spec

    class ___get_logs_spec(typing_extensions.Protocol):
        def __call__(self) -> typing.Generator[typing.Optional[bytes], None, None]: ...
        def aio(self) -> typing.AsyncGenerator[typing.Optional[bytes], None]: ...

    _get_logs: ___get_logs_spec

    class ___get_logs_by_line_spec(typing_extensions.Protocol):
        def __call__(self) -> typing.Generator[typing.Optional[bytes], None, None]: ...
        def aio(self) -> typing.AsyncGenerator[typing.Optional[bytes], None]: ...

    _get_logs_by_line: ___get_logs_by_line_spec

    def __iter__(self) -> typing.Iterator[T]: ...
    def __aiter__(self) -> typing.AsyncIterator[T]: ...
    def __next__(self) -> T: ...
    async def __anext__(self) -> T: ...

class StreamWriter:
    def __init__(
        self, object_id: str, object_type: typing.Literal["sandbox", "container_process"], client: modal.client.Client
    ): ...
    def get_next_index(self): ...
    def write(self, data: typing.Union[bytes, bytearray, memoryview, str]): ...
    def write_eof(self): ...

    class __drain_spec(typing_extensions.Protocol):
        def __call__(self): ...
        async def aio(self): ...

    drain: __drain_spec
